import pygame
import cell
import sign

class IntersectionBlock():
    def __init__(self, pivotX, pivotY ,cells):
        self.intersectioncells = [None,None,None,None]
        self.signLocation = [None,None,None,None]
        self.initiateBlock(pivotX, pivotY, cells)

    def initiateBlock(self, pivotX, pivotY, cells):
        print "YAY"
        self.intersectioncells[0] = cells[pivotX][pivotY+2]
        self.intersectioncells[1] = cells[pivotX+1][pivotY]
        self.intersectioncells[2] = cells[pivotX+3][pivotY+1]
        self.intersectioncells[3] = cells[pivotX+2][pivotY+3]
        self.intersectioncells[0].direction =  self.intersectioncells[2].direction = 0
        self.intersectioncells[1].direction =  self.intersectioncells[3].direction = 1
        for icell in self.intersectioncells:
            icell.block = self
        width = self.intersectioncells[0].style.width
        height = self.intersectioncells[0].style.height
        self.signLocation[0] = 15+(pivotX+0.5)*width, 15+(pivotY+3)*height
        self.signLocation[1] = 15+(pivotX+0.5)*width, 15+(pivotY+0.5)*height
        self.signLocation[2] = 15+(pivotX+3)*width, 15+(pivotY+0.5)*height
        self.signLocation[3] = 15+(pivotX+3)*width, 15+(pivotY+3)*height
        
    def updateBlock(self, red,green,direction):
        if (direction == 0):
            red0 = green1 = red
            red1 = green0 = green
            isRed = True
        else:
            red0 = green1 = green
            red1 = green0 = red
            isRed = False
        if (not self.intersectioncells[0].sign):
            self.intersectioncells[0].sign = sign.TrafficLight(red0,green0,self.signLocation[0])
            self.intersectioncells[1].sign = sign.TrafficLight(red1,green1,self.signLocation[1])
            self.intersectioncells[2].sign = sign.TrafficLight(red0,green0,self.signLocation[2])
            self.intersectioncells[3].sign = sign.TrafficLight(red1,green1,self.signLocation[3])
        else:
            self.intersectioncells[0].sign.setRedTime(red0)
            self.intersectioncells[1].sign.setRedTime(red1)
            self.intersectioncells[2].sign.setRedTime(red0)
            self.intersectioncells[3].sign.setRedTime(red1)
            self.intersectioncells[0].sign.setGreenTime(green0)
            self.intersectioncells[1].sign.setGreenTime(green1)
            self.intersectioncells[2].sign.setGreenTime(green0)
            self.intersectioncells[3].sign.setGreenTime(green1)
        self.intersectioncells[0].sign.redLight = self.intersectioncells[2].sign.redLight = isRed
        self.intersectioncells[1].sign.redLight = self.intersectioncells[3].sign.redLight = not isRed

    def removeSigns(self):
        for icell in self.intersectioncells:
            icell.sign = None
            
    def getIntersection():
        return self.intersectioncells
    
    def getTobeDrawnCells():
        return self.tobedrawnCells
    
